<?php

#Класс для работы с PDO#
#Class from work with PDO#

class MVCS_pdo {
	
	var $connection = array();
	var $connect_properties = array();
	var $use_connection;
	var $prepare;
	
	#Запрос на подключение#
	#Connection request#
	
	function MVCS_pdo(){
		GLOBAL $cfg;
		try{ $this->connection['default'] = new PDO($cfg['db']['db_type'].":host=".$cfg['db']['host'].";dbname=".$cfg['db']['database'].";charset=".$cfg['db']['char'], 
												$cfg['db']['user'], 
												$cfg['db']['password']);}
		catch(PDOException $e){
			echo '[MVCS_pdo:Ошибка|Error] Ошибка подключения к серверу | Error connect to server';
		}
		if ($this->connection['default']){
			$this->connection['default']->query("SET NAMES ".$cfg['db']['char']);
			$this->connect_properties['default'] = array(
												'host'=>$cfg['db']['host'],
												'user'=>$cfg['db']['user'],
												'password'=>$cfg['db']['password'],
												'char'=>$cfg['db']['char'],
												'db_type'=>$cfg['db']['db_type']
												);
				$this->use_connection = 'default';
				return true;
		}
		
	}
	
	#Закрытие соединения#
	#Close connection#
	
	function CloseConnection($connection){
		GLOBAL $cfg;
		$this->connection[$connection] = null;
	}
	
	#Открытие соединения#
	#Open connection#
	
	function OpenConnection($name,$host = '',$user = '',$password = '',$char = '',$db_type = ''){
		GLOBAL $cfg;
		#Три последних параметра не обязательны, если соединение устанавливалось ранее#
		#The last three parameters are optional, if the connection was set previously#
		
		if (isset($this->connection_properties[$name])){
		
			$host = $this->connection_properties[$name]['host'];
			$user = $this->connection_properties[$name]['user'];
			$password = $this->connection_properties[$name]['password'];
			$char = $this->connection_properties[$name]['char'];
			$db_type = $this->connection_properties[$name]['db_type'];
			
		}
		try{ $this->connection[$name] = new PDO($db_type.":host=".$host.";dbname=".$database.";charset=".$char, 
												$user, 
												$password);}
		catch(PDOException $e){
			echo '[MVCS_pdo:Ошибка|Error] Ошибка подключения к серверу | Error connect to server';
		}
		if ($this->connection[$name]){
			$this->connection[$name]->query("SET NAMES ".$char);
			$this->connect_properties[$name] = array(
												'host'=>$host,
												'user'=>$user,
												'password'=>$password,
												'char'=>$char,
												'db_type'=>$db_type
												);
				$this->use_connection = $name;
				return true;
		}
	
	}
	
	#Установка активного подключения#
	#Changing of the connection used#
	
	function UseConnection($name){
		GLOBAL $cfg;
		$this->use_connection = $name;
		
	}
	
	#Запрос к БД#
	#Request to DB#
	
	function Query($query){
		GLOBAL $cfg;
		if ($res = $this->connection[$this->use_connection]->query($query)){
			
			return $res;
			
		
		}else{
		
			echo '[MVCS_pdo:Ошибка|Error] Ошибка выполнения запроса | Error in query';
		
		}
		
	}
	
	#Подготовка запроса#
	#Prepare query#
	
	function Prepare($query,$arr_attr = null){
	
		GLOBAL $cfg;
		return $this->connection[$this->use_connection]->prepare($query,$arr_attr);
	
	
	}
	
	#Установка атрибутов подключения#
	#Set connection attribute#
	
	function SetAttribute($attribute,$value){
		GLOBAL $cfg;
		return $this->connection[$this->use_connection]->setAttribute($attribute,$value);
		
		
	}
	
	
	
	
	
}
	